using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Web.SessionState;
using System.Web.Services.Protocols;

namespace soapHeadercsharp
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	public class Service1 : System.Web.Services.WebService
	{
		/// <summary>
		/// SOAP Header per l'autenticazione
		/// </summary>
		public myHeader sHeader;

		public Service1()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		/// <summary>
		/// Metodo che controlla l'header di autenticazione
		/// </summary>
		/// <returns>Messaggio</returns>
		[WebMethod(Description="Metodo che controlla l'header di autenticazione")]
		[SoapHeader("sHeader")]
		public System.Xml.XmlDocument checkHeader()
		{
			//Stringa messaggio
			string strXMLMsg;
			//Oggetto XMLDocument 
			System.Xml.XmlDataDocument xmlTipi;
			xmlTipi = new System.Xml.XmlDataDocument();

			//Controllo che l'header non sia nullo
			if (sHeader != null)
			{
				//Ricavo login e password
				string usr = sHeader.Username;
				string pwd = sHeader.Password;
				//Costruisco il messaggio
				strXMLMsg = "<soapHeadercsharp><USER>"+ usr +"</USER><PASS>"+ pwd +"</PASS></soapHeadercsharp>";
			}
			else
			{			
				//Costruisco il messaggio
				strXMLMsg = "<soapHeadercsharp><ERROR>ERRORE</ERROR></soapHeadercsharp>";				
			}

			//Ritorno il messaggio
			xmlTipi.LoadXml(strXMLMsg);
			return xmlTipi;
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

	}

	/// <summary>
	/// SOAP Header per l'autenticazione
	/// </summary>
	public class myHeader : SoapHeader 
	{
		/// <summary>
		/// Username utente
		/// </summary>
		public string Username;
		/// <summary>
		/// Password utente
		/// </summary>
		public string Password;
	}
}
